# -*- coding: utf-8 -*-
from setuphelpers import *
import time


def install():

    print("installing Miniconda")
    versionpaquet = control.get_software_version()

    for miniconda in installed_softwares("Miniconda"):
        if "64-bit" in miniconda:
            if Version(miniconda["version"]) < Version(versionpaquet):
                if isfile(miniconda["uninstall_string"].replace('"', "")):
                    run(uninstall_cmd(miniconda["key"]))
                    time.sleep(20)

    for miniconda in installed_softwares("Miniconda"):
        if iswin64():
            if "32-bit" in miniconda["name"]:
                if isfile(miniconda["uninstall_string"].replace('"', "")):
                    run(uninstall_cmd(miniconda["key"]))
                    time.sleep(20)

    for miniconda in installed_softwares("Miniconda"):
        if not isfile(miniconda["uninstall_string"].replace('"', "")):
            if "64-bit" in miniconda["name"]:
                unregister_uninstall(miniconda["key"], win64app=True)
            else:
                unregister_uninstall(miniconda["key"], win64app=False)
    install_exe_if_needed(
        "Miniconda3-latest-Windows-x86_64.exe",
        "/S",
        name="Miniconda3",
        min_version=versionpaquet,
        get_version=get_app_path_version,
    )


def get_app_path_version(key):
    return key["version"].split("_")[-1]
